diff -ruN vdr-1.3.39/i18n.c vdr-1.3.40/i18n.c
--- vdr-1.3.39/i18n.c	2006-01-15 13:22:15.000000000 +0100
+++ vdr-1.3.40/i18n.c	2006-01-22 16:55:28.000000000 +0100
@@ -5566,7 +5587,7 @@
     "Ce plugin n'a pas de paramètres!",
     "",// TODO
     "Tällä laajennoksella ei ole asetuksia!",
-    "Ten plugin niema parametrow!",
+    "Ta wtyczka nie ma ¿adnych ustawieñ!",
     "Este plugin no admite configuración",
     "ÁõôÞ ç åðÝêôáóç äåí Ý÷åé ðáñÜìåôñïõò!",
     "Den här modulen har inga parametrar",
@@ -5587,8 +5608,8 @@
     "VDR Classique",// TODO
     "",// TODO
     "Klassinen VDR",
-    "",// TODO
-    "",// TODO
+    "Klasyczny VDR",
+    "VDR clásico",
     "Êëáóéêü VDR",
     "Klassisk VDR",
     "VDR clasic",
@@ -5608,8 +5629,8 @@
     "Consoles ST:TNG",
     "",// TODO
     "ST:TNG konsoli",
-    "",// TODO
-    "",// TODO
+    "Panel ST:TNG",
+    "Paneles ST:TNG",
     "ÌïñöÝò ST:TNG",
     "ST:TNG konsoll",
     "Cons. ST:TNG",
@@ -5629,8 +5650,8 @@
     "Sans titre",
     "",// TODO
     "Ei esitystä",
-    "",// TODO
-    "",// TODO
+    "Bez tytu³u",
+    "Sin título",
     "×ùñßò Ôßôëï",
     "ingen titel",
     "Fãrã titlu",
diff -ruN vdr-1.3.39/keys.c vdr-1.3.40/keys.c
--- vdr-1.3.39/keys.c	2006-01-05 16:39:26.000000000 +0100
+++ vdr-1.3.40/keys.c	2006-01-16 18:01:25.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.c 1.10 2006/01/05 15:39:26 kls Exp $
+ * $Id: keys.c 1.11 2006/01/16 17:01:25 kls Exp $
  */
 
 #include "keys.h"
@@ -250,9 +250,11 @@
 
 const cKeyMacro *cKeyMacros::Get(eKeys Key)
 {
-  for (cKeyMacro *k = First(); k; k = Next(k)) {
-      if (*k->Macro() == Key)
-         return k;
-      }
+  if (Key != kNone) {
+     for (cKeyMacro *k = First(); k; k = Next(k)) {
+         if (*k->Macro() == Key)
+            return k;
+         }
+     }
   return NULL;
 }
diff -ruN vdr-1.3.39/menu.c vdr-1.3.40/menu.c
--- vdr-1.3.39/menu.c	2006-01-15 16:02:36.000000000 +0100
+++ vdr-1.3.40/menu.c	2006-01-22 17:06:39.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.396 2006/01/15 15:02:36 kls Exp $
+ * $Id: menu.c 1.403 2006/01/22 16:06:39 kls Exp $
  */
 
 #include "menu.h"
@@ -36,6 +36,8 @@
 #define MAXRECORDCONTROLS (MAXDEVICES * MAXRECEIVERS)
 #define MAXINSTANTRECTIME (24 * 60 - 1) // 23:59 hours
 #define MAXWAITFORCAMMENU 4 // seconds to wait for the CAM menu to open
+#define MINFREEDISK       300 // minimum free disk space required to start recording
+#define NODISKSPACEDELTA  300 // seconds between "Not enough disk space to start recording!" messages
 
 #define CHNUMWIDTH  (numdigits(Channels.MaxNumber()) + 1)
 
@@ -2996,9 +2998,12 @@
 
 #define DIRECTCHANNELTIMEOUT 1000 //ms
 
+cDisplayChannel *cDisplayChannel::currentDisplayChannel = NULL;
+
 cDisplayChannel::cDisplayChannel(int Number, bool Switched)
 :cOsdObject(true)
 {
+  currentDisplayChannel = this;
   group = -1;
   withInfo = !Switched || Setup.ShowInfoOnChSwitch;
   displayChannel = Skins.Current()->DisplayChannel(withInfo);
@@ -3017,12 +3022,15 @@
 cDisplayChannel::cDisplayChannel(eKeys FirstKey)
 :cOsdObject(true)
 {
+  currentDisplayChannel = this;
   group = -1;
   number = 0;
+  timeout = true;
   lastPresent = lastFollowing = NULL;
   lastTime.Set();
   withInfo = Setup.ShowInfoOnChSwitch;
   displayChannel = Skins.Current()->DisplayChannel(withInfo);
+  channel = Channels.GetByNumber(cDevice::CurrentChannel());
   ProcessKey(FirstKey);
 }
 
@@ -3030,6 +3038,7 @@
 {
   delete displayChannel;
   cStatus::MsgOsdClear();
+  currentDisplayChannel = NULL;
 }
 
 void cDisplayChannel::DisplayChannel(void)
@@ -3063,14 +3072,27 @@
 
 void cDisplayChannel::Refresh(void)
 {
-  channel = Channels.GetByNumber(cDevice::CurrentChannel());
   DisplayChannel();
   displayChannel->SetEvents(NULL, NULL);
-  lastTime.Set();
+}
+
+cChannel *cDisplayChannel::NextAvailableChannel(cChannel *Channel, int Direction)
+{
+  if (Direction) {
+     while (Channel) {
+           Channel = Direction > 0 ? Channels.Next(Channel) : Channels.Prev(Channel);
+           if (Channel && !Channel->GroupSep() && cDevice::GetDevice(Channel, 0))
+              return Channel;
+           }
+     }
+  return NULL;
 }
 
 eOSState cDisplayChannel::ProcessKey(eKeys Key)
 {
+  cChannel *NewChannel = NULL;
+  if (Key != kNone)
+     lastTime.Set();
   switch (Key) {
     case k0:
          if (number == 0) {
@@ -3081,31 +3103,32 @@
     case k1 ... k9:
          if (number >= 0) {
             number = number * 10 + Key - k0;
-            if (number > 0) {
-               channel = Channels.GetByNumber(number);
-               displayChannel->SetEvents(NULL, NULL);
-               withInfo = false;
-               DisplayChannel();
-               lastTime.Set();
-               // Lets see if there can be any useful further input:
-               int n = channel ? number * 10 : 0;
-               cChannel *ch = channel;
-               while (ch && (ch = Channels.Next(ch)) != NULL) {
-                     if (!ch->GroupSep()) {
-                        if (n <= ch->Number() && ch->Number() <= n + 9) {
-                           n = 0;
-                           break;
-                           }
-                        if (ch->Number() > n)
-                           n *= 10;
+            channel = Channels.GetByNumber(number);
+            displayChannel->SetEvents(NULL, NULL);
+            withInfo = false;
+            DisplayChannel();
+            // Lets see if there can be any useful further input:
+            int n = channel ? number * 10 : 0;
+            int m = 10;
+            cChannel *ch = channel;
+            while (ch && (ch = Channels.Next(ch)) != NULL) {
+                  if (!ch->GroupSep()) {
+                     if (n <= ch->Number() && ch->Number() < n + m) {
+                        n = 0;
+                        break;
+                        }
+                     if (ch->Number() > n) {
+                        n *= 10;
+                        m *= 10;
                         }
                      }
-               if (n > 0) {
-                  // This channel is the only one that fits the input, so let's take it right away:
-                  displayChannel->Flush(); // makes sure the user sees his last input
-                  Channels.SwitchTo(number);
-                  return osEnd;
                   }
+            if (n > 0) {
+               // This channel is the only one that fits the input, so let's take it right away:
+               displayChannel->Flush(); // makes sure the user sees his last input
+               NewChannel = channel;
+               withInfo = true;
+               number = 0;
                }
             }
          break;
@@ -3136,18 +3159,27 @@
                   group = -1;
                }
             }
-         lastTime.Set();
          break;
     case kUp|k_Repeat:
     case kUp:
     case kDown|k_Repeat:
     case kDown:
-         cDevice::SwitchChannel(NORMALKEY(Key) == kUp ? 1 : -1);
-         // no break here
     case kChanUp|k_Repeat:
     case kChanUp:
     case kChanDn|k_Repeat:
-    case kChanDn:
+    case kChanDn: {
+         eKeys k = NORMALKEY(Key);
+         cChannel *ch = NextAvailableChannel(channel, (k == kUp || k == kChanUp) ? 1 : -1);
+         if (ch)
+            channel = ch;
+         }
+         // no break here
+    case kUp|k_Release:
+    case kDown|k_Release:
+    case kChanUp|k_Release:
+    case kChanDn|k_Release:
+         if (!(Key & k_Repeat) && channel)
+            NewChannel = channel;
          withInfo = true;
          group = -1;
          number = 0;
@@ -3155,43 +3187,57 @@
          break;
     case kNone:
          if (number && lastTime.Elapsed() > DIRECTCHANNELTIMEOUT) {
-            if (Channels.GetByNumber(number))
-               Channels.SwitchTo(number);
-            else {
-               number = 0;
-               channel = NULL;
-               DisplayChannel();
-               lastTime.Set();
-               return osContinue;
-               }
-            return osEnd;
+            channel = Channels.GetByNumber(number);
+            if (channel)
+               NewChannel = channel;
+            withInfo = true;
+            number = 0;
+            Refresh();
+            lastTime.Set();
             }
          break;
     //TODO
     //XXX case kGreen:  return osEventNow;
     //XXX case kYellow: return osEventNext;
-    case kOk:     if (group >= 0) {
-                     channel = Channels.Get(Channels.GetNextNormal(group));
-                     if (channel)
-                        Channels.SwitchTo(channel->Number());
-                     withInfo = true;
-                     group = -1;
-                     Refresh();
-                     break;
-                     }
-                  else if (number > 0 && channel)
-                     Channels.SwitchTo(number);
-                  return osEnd;
-    default:      if ((Key & (k_Repeat | k_Release)) == 0) {
-                     cRemote::Put(Key);
-                     return osEnd;
-                     }
+    case kOk:
+         if (group >= 0) {
+            channel = Channels.Get(Channels.GetNextNormal(group));
+            if (channel)
+               NewChannel = channel;
+            withInfo = true;
+            group = -1;
+            Refresh();
+            }
+         else if (number > 0) {
+            channel = Channels.GetByNumber(number);
+            if (channel)
+               NewChannel = channel;
+            withInfo = true;
+            number = 0;
+            Refresh();
+            }
+         else
+            return osEnd;
+         break;
+    default:
+         if ((Key & (k_Repeat | k_Release)) == 0) {
+            cRemote::Put(Key);
+            return osEnd;
+            }
     };
   if (!timeout || lastTime.Elapsed() < (uint64)(Setup.ChannelInfoTime * 1000)) {
-     if (!number && group < 0 && channel && channel->Number() != cDevice::CurrentChannel())
-        Refresh(); // makes sure a channel switch through the SVDRP CHAN command is displayed
+     if (Key == kNone && !number && group < 0 && !NewChannel && channel && channel->Number() != cDevice::CurrentChannel()) {
+        // makes sure a channel switch through the SVDRP CHAN command is displayed
+        channel = Channels.GetByNumber(cDevice::CurrentChannel());
+        Refresh();
+        lastTime.Set();
+        }
      DisplayInfo();
      displayChannel->Flush();
+     if (NewChannel) {
+        Channels.SwitchTo(NewChannel->Number());
+        channel = NewChannel;
+        }
      return osContinue;
      }
   return osEnd;
@@ -3520,6 +3566,23 @@
 
 bool cRecordControls::Start(cTimer *Timer, bool Pause)
 {
+  static time_t LastNoDiskSpaceMessage = 0;
+  int FreeMB = 0;
+  if (Timer) {
+     AssertFreeDiskSpace(Timer->Priority(), !Timer->Pending());
+     Timer->SetPending(true);
+     }
+  VideoDiskSpace(&FreeMB);
+  if (FreeMB < MINFREEDISK) {
+     if (!Timer || time(NULL) - LastNoDiskSpaceMessage > NODISKSPACEDELTA) {
+        isyslog("not enough disk space to start recording%s%s", Timer ? " timer " : "", Timer ? *Timer->ToDescr() : "");
+        Skins.Message(mtWarning, tr("Not enough disk space to start recording!"));
+        LastNoDiskSpaceMessage = time(NULL);
+        }
+     return false;
+     }
+  LastNoDiskSpaceMessage = 0;
+
   ChangeState();
   int ch = Timer ? Timer->Channel()->Number() : cDevice::CurrentChannel();
   cChannel *channel = Channels.GetByNumber(ch);
@@ -3548,8 +3611,10 @@
                }
            }
         }
-     else if (!Timer || (Timer->Priority() >= Setup.PrimaryLimit && !Timer->Pending()))
+     else if (!Timer || (Timer->Priority() >= Setup.PrimaryLimit && !Timer->Pending())) {
         isyslog("no free DVB device to record channel %d!", ch);
+        Skins.Message(mtError, tr("No free DVB device to record!"));
+        }
      }
   else
      esyslog("ERROR: channel %d not defined!", ch);
diff -ruN vdr-1.3.39/menu.h vdr-1.3.40/menu.h
--- vdr-1.3.39/menu.h	2006-01-06 12:30:38.000000000 +0100
+++ vdr-1.3.40/menu.h	2006-01-22 15:24:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.81 2006/01/06 11:30:38 kls Exp $
+ * $Id: menu.h 1.82 2006/01/22 14:24:31 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -82,14 +82,17 @@
   cChannel *channel;
   const cEvent *lastPresent;
   const cEvent *lastFollowing;
+  static cDisplayChannel *currentDisplayChannel;
   void DisplayChannel(void);
   void DisplayInfo(void);
   void Refresh(void);
+  cChannel *NextAvailableChannel(cChannel *Channel, int Direction);
 public:
   cDisplayChannel(int Number, bool Switched);
   cDisplayChannel(eKeys FirstKey);
   virtual ~cDisplayChannel();
   virtual eOSState ProcessKey(eKeys Key);
+  static bool IsOpen(void) { return currentDisplayChannel != NULL; }
   };
 
 class cDisplayVolume : public cOsdObject {
diff -ruN vdr-1.3.39/menuitems.c vdr-1.3.40/menuitems.c
--- vdr-1.3.39/menuitems.c	2006-01-07 16:37:03.000000000 +0100
+++ vdr-1.3.40/menuitems.c	2006-01-21 13:27:14.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.29 2006/01/07 15:37:03 kls Exp $
+ * $Id: menuitems.c 1.30 2006/01/21 12:27:14 kls Exp $
  */
 
 #include "menuitems.h"
@@ -15,6 +15,8 @@
 #include "skins.h"
 #include "status.h"
 
+#define AUTO_ADVANCE_TIMEOUT  1500 // ms before auto advance when entering characters via numeric keys
+
 const char *FileNameChars = " abcdefghijklmnopqrstuvwxyz0123456789-.#~,/_@";
 
 // --- cMenuEditItem ---------------------------------------------------------
@@ -262,6 +264,23 @@
      cSkinDisplay::Current()->SetButtons(NULL);
 }
 
+void cMenuEditStrItem::AdvancePos(void)
+{
+  if (pos < length - 2 && pos < int(strlen(value)) ) {
+     if (++pos >= int(strlen(value))) {
+        if (pos >= 2 && value[pos - 1] == ' ' && value[pos - 2] == ' ')
+           pos--; // allow only two blanks at the end
+        else {
+           value[pos] = ' ';
+           value[pos + 1] = 0;
+           }
+        }
+     }
+  newchar = true;
+  if (!insert && isalpha(value[pos]))
+     uppercase = isupper(value[pos]);
+}
+
 void cMenuEditStrItem::Set(void)
 {
   char buf[1000];
@@ -326,6 +345,13 @@
   bool SameKey = Key == lastKey;
   if (Key != kNone)
      lastKey = Key;
+  else if (!newchar && autoAdvanceTimeout.TimedOut()) {
+     AdvancePos();
+     newchar = true;
+     currentChar = NULL;
+     Set();
+     return osContinue;
+     }
   switch (Key) {
     case kRed:   // Switch between upper- and lowercase characters
                  if (InEditMode()) {
@@ -382,19 +408,7 @@
                     uppercase = isupper(value[pos]);
                  break;
     case kRight|k_Repeat:
-    case kRight: if (pos < length - 2 && pos < int(strlen(value)) ) {
-                    if (++pos >= int(strlen(value))) {
-                       if (pos >= 2 && value[pos - 1] == ' ' && value[pos - 2] == ' ')
-                          pos--; // allow only two blanks at the end
-                       else {
-                          value[pos] = ' ';
-                          value[pos + 1] = 0;
-                          }
-                       }
-                    }
-                 newchar = true;
-                 if (!insert && isalpha(value[pos]))
-                    uppercase = isupper(value[pos]);
+    case kRight: AdvancePos();
                  if (pos == 0)
                     SetHelpKeys();
                  break;
@@ -413,15 +427,19 @@
                        value[pos] = toupper(Inc(tolower(value[pos]), NORMALKEY(Key) == kUp));
                     else
                        value[pos] =         Inc(        value[pos],  NORMALKEY(Key) == kUp);
-                    newchar = false;
+                    newchar = true;
                     }
                  else
                     return cMenuEditItem::ProcessKey(Key);
                  break;
+    case k0|k_Repeat ... k9|k_Repeat:
     case k0 ... k9: {
-                 if (!SameKey)
-                    currentChar = NULL;
                  if (InEditMode()) {
+                    if (!SameKey) {
+                       if (!newchar)
+                          AdvancePos();
+                       currentChar = NULL;
+                       }
                     if (insert && newchar) {
                        // create a new character in insert mode
                        if (int(strlen(value)) < length - 1) {
@@ -445,6 +463,7 @@
                        currentChar++;
                        }
                     newchar = false;
+                    autoAdvanceTimeout.Set(AUTO_ADVANCE_TIMEOUT);
                     }
                  else
                     return cMenuEditItem::ProcessKey(Key);
diff -ruN vdr-1.3.39/menuitems.h vdr-1.3.40/menuitems.h
--- vdr-1.3.39/menuitems.h	2006-01-06 16:16:25.000000000 +0100
+++ vdr-1.3.40/menuitems.h	2006-01-21 11:45:55.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 1.15 2006/01/06 15:16:25 kls Exp $
+ * $Id: menuitems.h 1.16 2006/01/21 10:45:55 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
@@ -85,7 +85,9 @@
   const char *charMap;
   const char *currentChar;
   eKeys lastKey;
+  cTimeMs autoAdvanceTimeout;
   void SetHelpKeys(void);
+  void AdvancePos(void);
   virtual void Set(void);
   char Inc(char c, bool Up);
 protected:
diff -ruN vdr-1.3.39/recording.c vdr-1.3.40/recording.c
--- vdr-1.3.39/recording.c	2006-01-08 12:40:13.000000000 +0100
+++ vdr-1.3.40/recording.c	2006-01-20 18:18:59.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.132 2006/01/08 11:40:13 kls Exp $
+ * $Id: recording.c 1.133 2006/01/20 17:18:59 kls Exp $
  */
 
 #include "recording.h"
@@ -117,7 +117,7 @@
      }
 }
 
-void AssertFreeDiskSpace(int Priority)
+void AssertFreeDiskSpace(int Priority, bool Force)
 {
   static cMutex Mutex;
   cMutexLock MutexLock(&Mutex);
@@ -126,7 +126,7 @@
   // it will get removed during the next call.
   static time_t LastFreeDiskCheck = 0;
   int Factor = (Priority == -1) ? 10 : 1;
-  if (time(NULL) - LastFreeDiskCheck > DISKCHECKDELTA / Factor) {
+  if (Force || time(NULL) - LastFreeDiskCheck > DISKCHECKDELTA / Factor) {
      if (!VideoFileSpaceAvailable(MINDISKSPACE)) {
         // Make sure only one instance of VDR does this:
         cLockFile LockFile(VideoDirectory);
diff -ruN vdr-1.3.39/recording.h vdr-1.3.40/recording.h
--- vdr-1.3.39/recording.h	2005-12-18 12:26:51.000000000 +0100
+++ vdr-1.3.40/recording.h	2006-01-20 18:18:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 1.48 2005/12/18 11:26:51 kls Exp $
+ * $Id: recording.h 1.49 2006/01/20 17:18:28 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -21,9 +21,11 @@
 extern bool VfatFileSystem;
 
 void RemoveDeletedRecordings(void);
-void AssertFreeDiskSpace(int Priority = 0);
+void AssertFreeDiskSpace(int Priority = 0, bool Force = false);
      ///< The special Priority value -1 means that we shall get rid of any
      ///< deleted recordings faster than normal (because we're cutting).
+     ///< If Force is true, the check will be done even if the timeout
+     ///< hasn't expired yet.
 
 class cResumeFile {
 private:
diff -ruN vdr-1.3.39/tools.c vdr-1.3.40/tools.c
--- vdr-1.3.39/tools.c	2006-01-15 15:31:45.000000000 +0100
+++ vdr-1.3.40/tools.c	2006-01-20 15:01:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.110 2006/01/15 14:31:45 kls Exp $
+ * $Id: tools.c 1.112 2006/01/20 14:01:28 kls Exp $
  */
 
 #include "tools.h"
@@ -26,9 +26,22 @@
 #include <unistd.h>
 #include <utime.h>
 #include "i18n.h"
+#include "thread.h"
 
 int SysLogLevel = 3;
 
+#define MAXSYSLOGBUF 256
+
+void syslog_with_tid(int priority, const char *format, ...)
+{
+  va_list ap;
+  char fmt[MAXSYSLOGBUF];
+  snprintf(fmt, sizeof(fmt), "[%d] %s", cThread::ThreadId(), format);
+  va_start(ap, format);
+  vsyslog(priority, fmt, ap);
+  va_end(ap); 
+}
+
 int BCD2INT(int x)
 {
   return ((1000000 * BCDCHARTOINT((x >> 24) & 0xFF)) +
@@ -125,13 +138,14 @@
 
 char *strreplace(char *s, char c1, char c2)
 {
-  char *p = s;
-
-  while (p && *p) {
-        if (*p == c1)
-           *p = c2;
-        p++;
-        }
+  if (s) {
+     char *p = s;
+     while (*p) {
+           if (*p == c1)
+              *p = c2;
+           p++;
+           }
+     }
   return s;
 }
 
diff -ruN vdr-1.3.39/tools.h vdr-1.3.40/tools.h
--- vdr-1.3.39/tools.h	2006-01-08 12:40:37.000000000 +0100
+++ vdr-1.3.40/tools.h	2006-01-15 17:19:56.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.89 2006/01/08 11:40:37 kls Exp $
+ * $Id: tools.h 1.90 2006/01/15 16:19:56 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -26,9 +26,9 @@
 
 extern int SysLogLevel;
 
-#define esyslog(a...) void( (SysLogLevel > 0) ? syslog(LOG_ERR,   a) : void() )
-#define isyslog(a...) void( (SysLogLevel > 1) ? syslog(LOG_INFO,  a) : void() )
-#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog(LOG_DEBUG, a) : void() )
+#define esyslog(a...) void( (SysLogLevel > 0) ? syslog_with_tid(LOG_ERR,   a) : void() )
+#define isyslog(a...) void( (SysLogLevel > 1) ? syslog_with_tid(LOG_INFO,  a) : void() )
+#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog_with_tid(LOG_DEBUG, a) : void() )
 
 #define LOG_ERROR         esyslog("ERROR (%s,%d): %m", __FILE__, __LINE__)
 #define LOG_ERROR_STR(s)  esyslog("ERROR: %s: %m", s)
@@ -52,6 +52,8 @@
 template<class T> inline void swap(T &a, T &b) { T t = a; a = b; b = t; }
 #endif
 
+void syslog_with_tid(int priority, const char *format, ...);
+
 #define BCDCHARTOINT(x) (10 * ((x & 0xF0) >> 4) + (x & 0xF))
 int BCD2INT(int x);
 
diff -ruN vdr-1.3.39/transfer.c vdr-1.3.40/transfer.c
--- vdr-1.3.39/transfer.c	2005-08-14 12:55:03.000000000 +0200
+++ vdr-1.3.40/transfer.c	2006-01-21 15:13:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 1.30 2005/08/14 10:55:03 kls Exp $
+ * $Id: transfer.c 1.31 2006/01/21 14:13:16 kls Exp $
  */
 
 #include "transfer.h"
@@ -63,6 +63,7 @@
   int Result = 0;
 #ifdef FW_NEEDS_BUFFER_RESERVE_FOR_AC3
   bool GotBufferReserve = false;
+  GotBufferReserve = true; //XXX remove this line if you absolutely need the buffer reserve
   int RequiredBufferReserve = KILOBYTE(DvbCardWith4MBofSDRAM ? 288 : 576);
 #endif
   while (Running()) {
diff -ruN vdr-1.3.39/vdr.c vdr-1.3.40/vdr.c
--- vdr-1.3.39/vdr.c	2006-01-15 14:31:57.000000000 +0100
+++ vdr-1.3.40/vdr.c	2006-01-22 16:59:13.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.238 2006/01/15 13:31:57 kls Exp $
+ * $Id: vdr.c 1.244 2006/01/22 15:59:13 kls Exp $
  */
 
 #include <getopt.h>
@@ -447,7 +447,7 @@
   // Log file:
 
   if (SysLogLevel > 0)
-     openlog("vdr", LOG_PID | LOG_CONS, SysLogTarget);
+     openlog("vdr", LOG_CONS, SysLogTarget); // LOG_PID doesn't work as expected under NPTL
 
   // Check the video directory:
 
@@ -727,7 +727,7 @@
            LastChannel = cDevice::CurrentChannel();
            LastChannelChanged = time(NULL);
            }
-        if (time(NULL) - LastChannelChanged >= Setup.ZapTimeout && LastChannel != PreviousChannel[0] && LastChannel != PreviousChannel[1])
+        if (time(NULL) - LastChannelChanged >= Setup.ZapTimeout && LastChannel != PreviousChannel[PreviousChannelIndex])
            PreviousChannel[PreviousChannelIndex ^= 1] = LastChannel;
         // Timers and Recordings:
         if (!Timers.BeingEdited()) {
@@ -822,6 +822,7 @@
                   }
                }
                break;
+          // Direct main menu functions:
           #define DirectMainFunction(function)\
             DELETE_MENU;\
             if (cControl::Control())\
@@ -855,7 +856,15 @@
           case kChanUp:
           case kChanDn|k_Repeat:
           case kChanDn:
-               cDevice::SwitchChannel(NORMALKEY(key) == kChanUp ? 1 : -1);
+               if (!Interact)
+                  Menu = new cDisplayChannel(NORMALKEY(key));
+               else if (cDisplayChannel::IsOpen()) {
+                  Interact->ProcessKey(key);
+                  continue;
+                  }
+               else
+                  cDevice::SwitchChannel(NORMALKEY(key) == kChanUp ? 1 : -1);
+               key = kNone; // nobody else needs to see these keys
                break;
           // Volume control:
           case kVolUp|k_Repeat:
@@ -901,9 +910,7 @@
           case kRecord:
                if (!cControl::Control()) {
                   if (cRecordControls::Start())
-                     ;//XXX Skins.Message(mtInfo, tr("Recording"));
-                  else
-                     Skins.Message(mtError, tr("No free DVB device to record!"));
+                     Skins.Message(mtInfo, tr("Recording started"));
                   key = kNone; // nobody else needs to see this key
                   }
                break;
@@ -947,8 +954,6 @@
              case osRecord: DELETE_MENU;
                             if (cRecordControls::Start())
                                Skins.Message(mtInfo, tr("Recording started"));
-                            else
-                               Skins.Message(mtError, tr("No free DVB device to record!"));
                             break;
              case osRecordings:
                             DELETE_MENU;
@@ -985,7 +990,7 @@
            }
         else {
            // Key functions in "normal" viewing mode:
-           if (KeyMacros.Get(key)) {
+           if (key != kNone && KeyMacros.Get(key)) {
               cRemote::PutMacro(key);
               key = kNone;
               }
@@ -999,21 +1004,17 @@
                   }
              // Direct Channel Select:
              case k1 ... k9:
-                  Menu = new cDisplayChannel(key);
-                  break;
              // Left/Right rotates trough channel groups:
              case kLeft|k_Repeat:
              case kLeft:
              case kRight|k_Repeat:
              case kRight:
-                  Menu = new cDisplayChannel(NORMALKEY(key));
-                  break;
              // Up/Down Channel Select:
              case kUp|k_Repeat:
              case kUp:
              case kDown|k_Repeat:
              case kDown:
-                  cDevice::SwitchChannel(NORMALKEY(key) == kUp ? 1 : -1);
+                  Menu = new cDisplayChannel(NORMALKEY(key));
                   break;
              // Viewing Control:
              case kOk:   LastChannel = -1; break; // forces channel display
